// ========================================================
//
// 3402_D_Arc
// 28-01-23
// Based on CBP FBO 20-08-21
//
// ========================================================

#include <CBPFBO_StepperAX.h>
#define DEBUG true 

// parameters for desired arc
float radius;
float degrees;
float theta;

// see kinematics maths
float a;

// Steps as floats and u-longs
float nRF, nLF;
unsigned long nR, nL;

// motor speeds
int vL, vR;

// variables for the arc algorithm
float beta;
float prepR;
unsigned long  doneL, doneR;

void setup(){
  Serial.begin(9600); 
  // Desired arc radius and degrees
  radius = 300.0;
  degrees = 90.0;
  theta = degrees*PI/180.0;                      
  a = rob_dia/2.0;

  // Calc the steps needed nL and nR
  nRF = (theta/dx)*(radius - a);
  nLF = (theta/dx)*(radius + a);
  
  nR = ceil(nRF);
  nL = ceil(nLF);

  beta = nRF/nLF;

  vL = 15;
  vR = ceil(float(vL)*beta);
  
  if(DEBUG) cprintf("nL = %l, nR = %l\n",nL,nR);

  // Set motor speeds - need to experiment
  setSpeeds(vL,vR);

  // Wait a couple of seconds
  delay(2000);

while (doneL < nL) {
    stepMotors(1, 0);
    doneL += 1;
    prepR += beta;
    if(prepR > 1.0) {
        stepMotors(0,1);
        doneR += 1;
        prepR -= 1.0;  
    }
  }

  if (prepR > 0.5) {
    stepMotors(0,1);
    doneR += 1.0;
    prepR -= 1.0;
  }
}


void loop() {

 
                        
}
