// ========================================================
//
// 3402_D_Husky_JuncDetect
// 28-01-23
//
// ========================================================

#include <CBPFBO_StepperA.h>
#include "HUSKYLENS.h"
#include "SoftwareSerial.h"

#define DEBUG true 

#define wheelDia 49.9
#define axleLen 98.0

HUSKYLENS husky;

int xOrigin;
int xTarget;

void setup(){
  Serial.begin(9600); 
  setRobotParams(wheelDia,axleLen);
  Wire.begin();

  while( !husky.begin(Wire)){
    Serial.println("Check General Seetings >> Protocol Type >> I2C");
    Serial.println("Husky Configured");
    delay(100);
  }
  Serial.println("Husky Configured");
  husky.writeAlgorithm(ALGORITHM_LINE_TRACKING);
}


void loop() {

 if( !husky.request()) 
   cprintf("Recheck Connexions\n");
   
 if(husky.available()){
    HUSKYLENSResult result = husky.read();
    xOrigin = result.xOrigin;
    xTarget = result.xTarget;
    cprintf("xTarget - xOrigin = %d\n",xTarget - xOrigin);
    
 }
                        
}

float getErrorX() {
  float error;
  error = (float)xOrigin - 160,
  error = -error/160;
  return error;
}
