// =================================================================
//
// CBPFBO_Stepper.half// 20-08-21
//
// =================================================================

#ifndef __CBPFBO_STEPPER_H
#define __CBPFBO_STEPPER_H

#include <Stepper.h>
#include <Pixy2.h>

#define dx 0.07225
#define rob_dia 94

#define TEE 1
#define LEFT 2
#define RIGHT 4

const int stepsPerRevolution = 2038; 
Stepper stepperL(stepsPerRevolution, 4, 6, 5, 7);
Stepper stepperR(stepsPerRevolution, 8, 10, 9, 11);

float offset = 0;

void stepMotors(Stepper stepperL, Stepper stepperR, int stepLeft, int stepRight);

int ramp(int vMin, int vMax, int N, float alpha, int n, bool upRamp, bool downRamp);

void straightLine(Stepper stepperL, Stepper stepperR, int dist, int vMax, bool upRamp, bool downRamp); 

int detectCorner(int16_t angs[]);

// Function for path tracking. Moves forward, detects junction, breaks
// out of movement while(...) then advances half a track width, then
// samples juntion type to return. Then advances until wheels on then
// junction, then returns.
	
int moveForward(Stepper stepperL, Stepper stepperR, Pixy2 pixy, int vMax, int dist);
 
// pivot function handles positive and negative angles (degrees)
void pivot(Stepper stepperL, Stepper stepperR,float degs);
 
void arc(Stepper stepperL, Stepper stepperR, float R, float a, float theta, int vMax, bool upRamp, bool downRamp);
 
// Get error = leftVal - rightVal. Normalize by maxDiff
float getError();

// Move depending on error
void moveABit(Stepper stepperL, Stepper stepperR, float error, float deltaT);

long RCTime(int sensorIn);

#endif