// =================================================================
//
// CBPFBO_Stepper.half// 20-08-21
//
// =================================================================

#ifndef __CBPFBO_STEPPER_H
#define __CBPFBO_STEPPER_H

void stepMotors(int stepLeft, int stepRight);

int ramp(int vMin, int vMax, int N, float alpha, int n, bool upRamp, bool downRamp);

void straightLine(int dist, int vMax, bool upRamp, bool downRamp); 

int detectCorner(int16_t angs[]);

// Function for path tracking. Moves forward, detects junction, breaks
// out of movement while(...) then advances half a track width, then
// samples juntion type to return. Then advances until wheels on then
// junction, then returns.
	
int moveForward(int vMax, int dist);
 
// pivot function handles positive and negative angles (degrees)
void pivot(float degs);
 
void arc(float R, float a, float theta, int vMax, bool upRamp, bool downRamp);
 
// Get error = leftVal - rightVal. Normalize by maxDiff
float getError();

// Move depending on error
void moveABit(float error, float deltaT);
 
#endif