// =================================================================
//
// CBPFBO_StepperA.h
// 20-08-21
// Revs. 22-08-21, 31-10-21, 17-11-22, 08-01-23
//
// =================================================================


#ifndef CBPFBO_STEPPERA_H
#define CBPFBO_STEPPERA_H

#include <Arduino.h>
#include <Stepper.h>
#include <Pixy2.h>

//#define wheelDia 49.9
//#define wheelRad (wheelDia/2.0)
#define stepsPerRev 2038
//#define dx ((PI*wheelDia)/stepsPerRev)
//#define rob_dia 100.0

#define TEE 1
#define LEFT 2
#define RIGHT 4
#define NONE 0


void setRobotParams(float wheelDia_, float axleLen_);

float getDX();

void stepMotors( int stepLeft, int stepRight);

void setStepperSpeeds(int leftSpeed, int rightSpeed);

int ramp(int vMin, int vMax, unsigned long N, float alpha, unsigned long n, bool upRamp, bool downRamp);

void straightLine(int dist, int vMax, bool upRamp, bool downRamp); 

int detectCorner(int16_t angs[]);

int detectCornersOrig(int16_t angs[]);

int detectCorners(int16_t angs[]);

// Function for path tracking. Moves forward, detects junction, breaks
// out of movement while(...) then advances half a track width, then
// samples juntion type to return. Then advances until wheels on then
// junction, then returns. 

// Copied from Parallax version (working). This code is under development
	
int moveForward(Pixy2 pixy, int vMax, int dist);
 
// pivot function handles positive and negative angles (degrees)
void pivot(float degs, int vMax, bool upRamp, bool downRamp);

// arc now handles positive and negative theta
void arc(float R, float theta, int vMax, bool upRamp, bool downRamp);
 
// Get error = leftVal - rightVal. Normalize by maxDiff
float getError();

// Move depending on error
void moveABit(	float error, float deltaT);

// IRed Reflectance Sensing
long RCTime(int sensorIn);

#endif
