// =================================================================
//
// CBPFBO_StepperAX.cpp
//12-02-22
// Cut down version of CBPFBO_StepperA.h (20-08-21, 22-08-21
// For 3402 Harry Mini-Project
//
// =================================================================

#include "CBPFBO_StepperAX.h"
#include <Pixy2.h>

int sspeed;
int speedL;
int speedR;

const int stepsPerRevolution = 2038; 
 
Stepper stepperR(stepsPerRevolution, 4, 6, 5, 7);
Stepper stepperL(stepsPerRevolution, 8, 10, 9, 11);

void stepMotors(int stepLeft, int stepRight) {
    stepperR.step(stepRight);
    stepperL.step(-stepLeft);
}

void setSpeeds(int speedLeft, int speedRight) {
	stepperL.setSpeed(speedLeft);
	stepperR.setSpeed(speedRight);
}

int ramp(int vMin, int vMax, unsigned long N, float alpha, unsigned long n, bool upRamp, bool downRamp) {

  int vely;
  
  if((n < alpha*N) && (upRamp == true)) {
    vely = n*(vMax - vMin)/(alpha*N) + vMin;
  }
  else if ((n < alpha*N) && (upRamp == false)) {
    vely = vMax;
  }
  
  if((n >= alpha*N) && (n < (N - alpha*N))) {
    vely = vMax;
  }

  if((n >= (N - alpha*N)) && (downRamp == true)) {
    vely = (N - n)*(vMax - vMin)/(alpha*N) + vMin;
  }
  else if ((n >= (N - alpha*N)) && (downRamp == false)) {
    vely = vMax;
  }

  if(upRamp == false && downRamp == false) {
    vely = vMax;
  }

  return vely;
  
}

